Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/TimeSpanValue.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/TimeSpanValue.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/TimeSpanValue.cs	(revision 16171)
@@ -0,0 +1,94 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Globalization;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("TimeSpanValue", "Represents a duration of time.")]
+  [StorableClass]
+  public class TimeSpanValue : ValueTypeValue<TimeSpan>, IComparable, IStringConvertibleValue {
+    [StorableConstructor]
+    protected TimeSpanValue(bool deserializing) : base(deserializing) { }
+    protected TimeSpanValue(TimeSpanValue original, Cloner cloner)
+      : base(original, cloner) {
+    }
+    public TimeSpanValue() : base() { }
+    public TimeSpanValue(TimeSpan value) : base(value) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TimeSpanValue(this, cloner);
+    }
+
+    public virtual int CompareTo(object obj) {
+      TimeSpanValue other = obj as TimeSpanValue;
+      if (other != null)
+        return Value.CompareTo(other.Value);
+      else
+        return Value.CompareTo(obj);
+    }
+
+    protected virtual bool Validate(string value, out string errorMessage) {
+      TimeSpan val;
+      bool valid = TimeSpan.TryParseExact(value, "c", CultureInfo.CurrentCulture, out val);
+      errorMessage = string.Empty;
+      if (!valid) {
+        StringBuilder sb = new StringBuilder();
+        sb.Append("Invalid Value (Valid Value Format: \"");
+        sb.Append(FormatPatterns.GetTimeSpanFormatPattern());
+        sb.Append("\")");
+        errorMessage = sb.ToString();
+      }
+      return valid;
+    }
+    protected virtual string GetValue() {
+      return Value.ToString("c");
+    }
+    protected virtual bool SetValue(string value) {
+      TimeSpan val;
+      if (TimeSpan.TryParseExact(value, "c", CultureInfo.CurrentCulture, out val)) {
+        Value = val;
+        return true;
+      } else {
+        return false;
+      }
+    }
+    public override string ToString() {
+      return Value.ToString("c");
+    }
+
+    #region IStringConvertibleValue Members
+    bool IStringConvertibleValue.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    string IStringConvertibleValue.GetValue() {
+      return GetValue();
+    }
+    bool IStringConvertibleValue.SetValue(string value) {
+      return SetValue(value);
+    }
+    #endregion
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/TriangularMatrix.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/TriangularMatrix.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/TriangularMatrix.cs	(revision 16171)
@@ -0,0 +1,212 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("TriangularMatrix", "Represents a lower triangular matrix.")]
+  [StorableClass]
+  public class TriangularMatrix<T> : ValueTypeMatrix<T>, IStringConvertibleMatrix where T : struct {
+    [Storable]
+    private readonly T[] storage;
+
+    private readonly int dimension;
+    private readonly long capacity;
+
+    private TriangularMatrix() { }
+
+    public TriangularMatrix(int dimension) {
+      this.dimension = dimension;
+      capacity = (long)dimension * (dimension + 1) / 2;
+      storage = new T[capacity];
+
+      readOnly = true;
+    }
+
+    [StorableConstructor]
+    protected TriangularMatrix(bool deserializing) : base(deserializing) { }
+
+    protected TriangularMatrix(TriangularMatrix<T> original, Cloner cloner) : base(original, cloner) {
+      capacity = original.capacity;
+      dimension = original.dimension;
+      storage = (T[])original.storage.Clone();
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TriangularMatrix<T>(this, cloner);
+    }
+
+    public override int Rows {
+      get { return dimension; }
+      protected set { throw new NotSupportedException(); }
+    }
+
+    public override int Columns {
+      get { return dimension; }
+      protected set { throw new NotSupportedException(); }
+    }
+
+    public int Length { get { return storage.Length; } }
+
+    // the indexing rule for the (lower-)triangular matrix is that always i <= j, otherwise an IndexOutOfBounds exception will occur 
+    public override T this[int rowIndex, int columnIndex] {
+      get {
+        // provide symmetry of returned values 
+        if (columnIndex > rowIndex) return this[columnIndex, rowIndex];
+        return storage[rowIndex * (rowIndex + 1) / 2 + columnIndex];
+      }
+      set {
+        if (columnIndex > rowIndex) this[columnIndex, rowIndex] = value;
+        else storage[rowIndex * (rowIndex + 1) / 2 + columnIndex] = value;
+      }
+    }
+
+    public T this[int index] {
+      get { return storage[index]; }
+      set { storage[index] = value; }
+    }
+
+    protected virtual string GetValue(int rowIndex, int columnIndex) {
+      return this[rowIndex, columnIndex].ToString(); // see above indexing rule
+    }
+
+    protected virtual bool SetValue(string value, int rowIndex, int columnIndex) {
+      T val;
+      if (!TryParse(value, out val))
+        return false;
+      this[rowIndex, columnIndex] = val;
+      return true;
+    }
+
+    protected virtual bool Validate(string value, out string errorMessage) {
+      T val;
+      errorMessage = "";
+      if (!TryParse(value, out val)) {
+        errorMessage = string.Format("Could not parse string \"{0}\" as {1}.", value, typeof(T));
+        return false;
+      }
+      return true;
+    }
+
+    public override IEnumerator<T> GetEnumerator() {
+      return storage.Cast<T>().GetEnumerator();
+    }
+
+    private static bool TryParse(string value, out T val) {
+      if (typeof(T) == typeof(sbyte)) {
+        sbyte v;
+        if (sbyte.TryParse(value, out v)) {
+          val = (T)(object)v;
+          return true;
+        }
+      } else if (typeof(T) == typeof(byte)) {
+        byte v;
+        if (byte.TryParse(value, out v)) {
+          val = (T)(object)v;
+          return true;
+        }
+      } else if (typeof(T) == typeof(char)) {
+        char v;
+        if (char.TryParse(value, out v)) {
+          val = (T)(object)v;
+          return true;
+        }
+      } else if (typeof(T) == typeof(short)) {
+        short v;
+        if (short.TryParse(value, out v)) {
+          val = (T)(object)v;
+          return true;
+        }
+      } else if (typeof(T) == typeof(ushort)) {
+        ushort v;
+        if (ushort.TryParse(value, out v)) {
+          val = (T)(object)v;
+          return true;
+        }
+      } else if (typeof(T) == typeof(int)) {
+        int v;
+        if (int.TryParse(value, out v)) {
+          val = (T)(object)v;
+          return true;
+        }
+      } else if (typeof(T) == typeof(uint)) {
+        uint v;
+        if (uint.TryParse(value, out v)) {
+          val = (T)(object)v;
+          return true;
+        }
+      } else if (typeof(T) == typeof(long)) {
+        long v;
+        if (long.TryParse(value, out v)) {
+          val = (T)(object)v;
+          return true;
+        }
+      } else if (typeof(T) == typeof(ulong)) {
+        ulong v;
+        if (ulong.TryParse(value, out v)) {
+          val = (T)(object)v;
+          return true;
+        }
+      }
+      val = default(T);
+      return false;
+    }
+
+    public void GetMatrixCoordinates(int index, out int row, out int col) {
+      var root = TriangularRoot(index);
+      row = (int)Math.Floor(root);
+      col = index - row * (row + 1) / 2;
+    }
+
+    private static double TriangularRoot(double x) {
+      return (Math.Sqrt(8 * x + 1) - 1) / 2;
+    }
+
+    #region IStringConvertibleMatrix Members
+    int IStringConvertibleMatrix.Rows {
+      get { return dimension; }
+      set { throw new NotSupportedException("The triangular matrix does not support changing the number of rows."); }
+    }
+
+    int IStringConvertibleMatrix.Columns {
+      get { return dimension; }
+      set { throw new NotSupportedException("The triangular matrix does not support changing the number of columns."); }
+    }
+
+    string IStringConvertibleMatrix.GetValue(int rowIndex, int columnIndex) {
+      return GetValue(rowIndex, columnIndex);
+    }
+
+    bool IStringConvertibleMatrix.SetValue(string value, int rowIndex, int columnIndex) {
+      return SetValue(value, rowIndex, columnIndex);
+    }
+
+    bool IStringConvertibleMatrix.Validate(string value, out string errorMessage) {
+      return Validate(value, out errorMessage);
+    }
+    #endregion
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/ValueTypeArray.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/ValueTypeArray.cs	(revision 16171)
@@ -0,0 +1,210 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("ValueTypeArray", "An abstract base class for representing arrays of value types.")]
+  [StorableClass]
+  public abstract class ValueTypeArray<T> : Item, IValueTypeArray<T> where T : struct {
+    private const int maximumToStringLength = 100;
+
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
+    }
+
+    [Storable]
+    protected T[] array;
+
+    [Storable]
+    protected List<string> elementNames;
+    public virtual IEnumerable<string> ElementNames {
+      get { return this.elementNames; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("ElementNames cannot be set. ValueTypeArray is read-only.");
+        if (value == null || !value.Any())
+          elementNames = new List<string>();
+        else if (value.Count() > Length)
+          throw new ArgumentException("The number of element names must not exceed the array length.");
+        else
+          elementNames = new List<string>(value);
+        OnElementNamesChanged();
+      }
+    }
+
+    public virtual int Length {
+      get { return array.Length; }
+      #region Mono Compatibility
+      // this setter should be protected, but the Mono compiler couldn't handle it
+      set {
+        if (ReadOnly) throw new NotSupportedException("Length cannot be set. ValueTypeArray is read-only.");
+        if (value != Length) {
+          Array.Resize<T>(ref array, value);
+          while (elementNames.Count > value)
+            elementNames.RemoveAt(elementNames.Count - 1);
+          OnElementNamesChanged();
+          OnReset();
+        }
+      }
+      #endregion
+    }
+
+    public int Count
+    {
+      get { return Length; }
+    }
+
+    [Storable]
+    protected bool resizable = true;
+    public bool Resizable {
+      get { return resizable; }
+      set {
+        if (resizable != value) {
+          resizable = value;
+          OnResizableChanged();
+        }
+      }
+    }
+
+
+    public virtual T this[int index] {
+      get { return array[index]; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("Item cannot be set. ValueTypeArray is read-only.");
+        if (!value.Equals(array[index])) {
+          array[index] = value;
+          OnItemChanged(index);
+        }
+      }
+    }
+
+    [Storable]
+    protected bool readOnly;
+    public virtual bool ReadOnly {
+      get { return readOnly; }
+    }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    private void AfterDeserialization() {
+      if (elementNames == null) { elementNames = new List<string>(); }
+    }
+
+    [StorableConstructor]
+    protected ValueTypeArray(bool deserializing) : base(deserializing) { }
+    protected ValueTypeArray(ValueTypeArray<T> original, Cloner cloner)
+      : base(original, cloner) {
+      this.array = (T[])original.array.Clone();
+      this.readOnly = original.readOnly;
+      this.resizable = original.resizable;
+      this.elementNames = new List<string>(original.elementNames);
+    }
+    protected ValueTypeArray() {
+      array = new T[0];
+      readOnly = false;
+      resizable = true;
+      elementNames = new List<string>();
+    }
+    protected ValueTypeArray(int length) {
+      array = new T[length];
+      readOnly = false;
+      resizable = true;
+      elementNames = new List<string>();
+    }
+    protected ValueTypeArray(T[] elements) {
+      if (elements == null) throw new ArgumentNullException();
+      array = (T[])elements.Clone();
+      readOnly = false;
+      resizable = true;
+      elementNames = new List<string>();
+    }
+
+    public virtual IValueTypeArray AsReadOnly() {
+      ValueTypeArray<T> readOnlyValueTypeArray = (ValueTypeArray<T>)this.Clone();
+      readOnlyValueTypeArray.readOnly = true;
+      return readOnlyValueTypeArray;
+    }
+
+    public T[] CloneAsArray() {
+      //mkommend: this works because T must be a value type (struct constraint);
+      return (T[])array.Clone();
+    }
+
+    public override string ToString() {
+      if (array.Length == 0) return "[]";
+
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[");
+      sb.Append(array[0].ToString());
+      for (int i = 1; i < array.Length; i++) {
+        sb.Append(";").Append(array[i].ToString());
+        if (sb.Length > maximumToStringLength) {
+          sb.Append("...");
+          break;
+        }
+      }
+      sb.Append("]");
+      return sb.ToString();
+    }
+
+    public virtual IEnumerator<T> GetEnumerator() {
+      return array.Cast<T>().GetEnumerator();
+    }
+
+    IEnumerator IEnumerable.GetEnumerator() {
+      return GetEnumerator();
+    }
+
+    public event EventHandler ResizableChanged;
+    protected virtual void OnResizableChanged() {
+      EventHandler handler = ResizableChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler ElementNamesChanged;
+    protected virtual void OnElementNamesChanged() {
+      EventHandler handler = ElementNamesChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+
+    public event EventHandler<EventArgs<int>> ItemChanged;
+    protected virtual void OnItemChanged(int index) {
+      if (ItemChanged != null)
+        ItemChanged(this, new EventArgs<int>(index));
+      if (index < maximumToStringLength)
+        OnToStringChanged();
+    }
+    public event EventHandler Reset;
+    protected virtual void OnReset() {
+      if (Reset != null)
+        Reset(this, EventArgs.Empty);
+      OnToStringChanged();
+    }
+  }
+}
Index: branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/ValueTypeMatrix.cs
===================================================================
--- branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/ValueTypeMatrix.cs	(revision 16171)
+++ branches/2943_MOBasicProblem_MOCMAES/HeuristicLab.Data/3.3/ValueTypeMatrix.cs	(revision 16171)
@@ -0,0 +1,293 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2018 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections;
+using System.Collections.Generic;
+using System.Drawing;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Data {
+  [Item("ValueTypeMatrix", "An abstract base class for representing matrices of value types.")]
+  [StorableClass]
+  public abstract class ValueTypeMatrix<T> : Item, IEnumerable<T> where T : struct {
+    private const int maximumToStringLength = 100;
+
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Class; }
+    }
+
+    [Storable]
+    protected T[,] matrix;
+
+    [Storable]
+    protected List<string> columnNames;
+    public virtual IEnumerable<string> ColumnNames {
+      get { return this.columnNames; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("ColumnNames cannot be set. ValueTypeMatrix is read-only.");
+        if (value == null || value.Count() == 0)
+          columnNames = new List<string>();
+        else if (value.Count() != Columns)
+          throw new ArgumentException("A column name must be specified for each column.");
+        else
+          columnNames = new List<string>(value);
+        OnColumnNamesChanged();
+      }
+    }
+    [Storable]
+    protected List<string> rowNames;
+    public virtual IEnumerable<string> RowNames {
+      get { return this.rowNames; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("RowNames cannot be set. ValueTypeMatrix is read-only.");
+        if (value == null || value.Count() == 0)
+          rowNames = new List<string>();
+        else if (value.Count() != Rows)
+          throw new ArgumentException("A row name must be specified for each row.");
+        else
+          rowNames = new List<string>(value);
+        OnRowNamesChanged();
+      }
+    }
+    [Storable]
+    protected bool sortableView;
+    public virtual bool SortableView {
+      get { return sortableView; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("SortableView cannot be set. ValueTypeMatrix is read-only.");
+        if (value != sortableView) {
+          sortableView = value;
+          OnSortableViewChanged();
+        }
+      }
+    }
+
+    public virtual int Rows {
+      get { return matrix.GetLength(0); }
+      protected set {
+        if (ReadOnly) throw new NotSupportedException("Rows cannot be set. ValueTypeMatrix is read-only.");
+        if (value != Rows) {
+          T[,] newArray = new T[value, Columns];
+          Array.Copy(matrix, newArray, Math.Min(value * Columns, matrix.Length));
+          matrix = newArray;
+          while (rowNames.Count > value)
+            rowNames.RemoveAt(rowNames.Count - 1);
+          while (rowNames.Count < value)
+            rowNames.Add("Row " + rowNames.Count);
+          OnRowsChanged();
+          OnRowNamesChanged();
+          OnReset();
+        }
+      }
+    }
+    public virtual int Columns {
+      get { return matrix.GetLength(1); }
+      protected set {
+        if (ReadOnly) throw new NotSupportedException("Columns cannot be set. ValueTypeMatrix is read-only.");
+        if (value != Columns) {
+          T[,] newArray = new T[Rows, value];
+          for (int i = 0; i < Rows; i++)
+            Array.Copy(matrix, i * Columns, newArray, i * value, Math.Min(value, Columns));
+          matrix = newArray;
+          while (columnNames.Count > value)
+            columnNames.RemoveAt(columnNames.Count - 1);
+          while (columnNames.Count < value)
+            columnNames.Add("Column " + columnNames.Count);
+          OnColumnsChanged();
+          OnColumnNamesChanged();
+          OnReset();
+        }
+      }
+    }
+    public virtual T this[int rowIndex, int columnIndex] {
+      get { return matrix[rowIndex, columnIndex]; }
+      set {
+        if (ReadOnly) throw new NotSupportedException("Item cannot be set. ValueTypeMatrix is read-only.");
+        if (!value.Equals(matrix[rowIndex, columnIndex])) {
+          matrix[rowIndex, columnIndex] = value;
+          OnItemChanged(rowIndex, columnIndex);
+        }
+      }
+    }
+
+    [Storable]
+    protected bool readOnly;
+    public virtual bool ReadOnly {
+      get { return readOnly; }
+    }
+
+    [StorableConstructor]
+    protected ValueTypeMatrix(bool deserializing) : base(deserializing) { }
+    protected ValueTypeMatrix(ValueTypeMatrix<T> original, Cloner cloner)
+      : base(original, cloner) {
+      this.matrix = (T[,])original.matrix.Clone();
+      this.columnNames = new List<string>(original.columnNames);
+      this.rowNames = new List<string>(original.rowNames);
+      this.sortableView = original.sortableView;
+      this.readOnly = original.readOnly;
+    }
+    protected ValueTypeMatrix() {
+      matrix = new T[0, 0];
+      columnNames = new List<string>();
+      rowNames = new List<string>();
+      sortableView = false;
+      readOnly = false;
+    }
+    protected ValueTypeMatrix(int rows, int columns) {
+      matrix = new T[rows, columns];
+      columnNames = new List<string>();
+      rowNames = new List<string>();
+      sortableView = false;
+      readOnly = false;
+    }
+    protected ValueTypeMatrix(int rows, int columns, IEnumerable<string> columnNames)
+      : this(rows, columns) {
+      ColumnNames = columnNames;
+    }
+    protected ValueTypeMatrix(int rows, int columns, IEnumerable<string> columnNames, IEnumerable<string> rowNames)
+      : this(rows, columns, columnNames) {
+      RowNames = rowNames;
+    }
+    protected ValueTypeMatrix(T[,] elements) {
+      if (elements == null) throw new ArgumentNullException();
+      matrix = (T[,])elements.Clone();
+      columnNames = new List<string>();
+      rowNames = new List<string>();
+      sortableView = false;
+      readOnly = false;
+    }
+    protected ValueTypeMatrix(T[,] elements, IEnumerable<string> columnNames)
+      : this(elements) {
+      ColumnNames = columnNames;
+    }
+    protected ValueTypeMatrix(T[,] elements, IEnumerable<string> columnNames, IEnumerable<string> rowNames)
+      : this(elements, columnNames) {
+      RowNames = rowNames;
+    }
+
+    public virtual ValueTypeMatrix<T> AsReadOnly() {
+      ValueTypeMatrix<T> readOnlyValueTypeMatrix = (ValueTypeMatrix<T>)this.Clone();
+      readOnlyValueTypeMatrix.readOnly = true;
+      return readOnlyValueTypeMatrix;
+    }
+
+   
+    public T[,] CloneAsMatrix() {
+      //mkommend: this works because T must be a value type (struct constraint);
+      return (T[,])matrix.Clone();
+    }
+
+    public virtual IEnumerable<T> GetRow(int row) {
+      for (var col = 0; col < Columns; col++) {
+        yield return matrix[row, col];
+      }
+    }
+
+    public virtual IEnumerable<T> GetColumn(int col) {
+      for (var row = 0; row < Rows; row++) {
+        yield return matrix[row, col];
+      }
+    }
+
+    public override string ToString() {
+      if (matrix.Length == 0) return "[]";
+
+      StringBuilder sb = new StringBuilder();
+      sb.Append("[");
+      for (int i = 0; i < Rows; i++) {
+        sb.Append("[").Append(matrix[i, 0].ToString());
+        for (int j = 1; j < Columns; j++)
+          sb.Append(";").Append(matrix[i, j].ToString());
+        sb.Append("]");
+
+        if (sb.Length > maximumToStringLength) {
+          sb.Append("[...]");
+          break;
+        }
+      }
+      sb.Append("]");
+
+      return sb.ToString();
+    }
+
+    public virtual IEnumerator<T> GetEnumerator() {
+      return matrix.Cast<T>().GetEnumerator();
+    }
+
+    IEnumerator IEnumerable.GetEnumerator() {
+      return GetEnumerator();
+    }
+
+    #region events
+    public event EventHandler ColumnsChanged;
+    protected virtual void OnColumnsChanged() {
+      EventHandler handler = ColumnsChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler RowsChanged;
+    protected virtual void OnRowsChanged() {
+      EventHandler handler = RowsChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler ColumnNamesChanged;
+    protected virtual void OnColumnNamesChanged() {
+      EventHandler handler = ColumnNamesChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler RowNamesChanged;
+    protected virtual void OnRowNamesChanged() {
+      EventHandler handler = RowNamesChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler SortableViewChanged;
+    protected virtual void OnSortableViewChanged() {
+      EventHandler handler = SortableViewChanged;
+      if (handler != null)
+        handler(this, EventArgs.Empty);
+    }
+    public event EventHandler<EventArgs<int, int>> ItemChanged;
+    protected virtual void OnItemChanged(int rowIndex, int columnIndex) {
+      if (ItemChanged != null)
+        ItemChanged(this, new EventArgs<int, int>(rowIndex, columnIndex));
+
+      //approximation to avoid firing of unnecessary ToStringChangedEvents
+      //columnIndex is not used, because always full rows are returned in the ToString method
+      if (rowIndex * Columns < maximumToStringLength)
+        OnToStringChanged();
+    }
+    public event EventHandler Reset;
+    protected virtual void OnReset() {
+      if (Reset != null)
+        Reset(this, EventArgs.Empty);
+      OnToStringChanged();
+    }
+    #endregion
+  }
+}
